/**
 * Wet dream section of the home scene.
 * @param {HomeController} controller The home controller.
 */
function HomeWetDream(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueHamletId = `toHamletContinueButton`;
    var continueVaranarId = `toVaranarContinueButton`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.gender() === GenderEnum.MALE;
        var sawDragoness = global.kobold.history.shared.dragonessPrincess.relation !== DragonessPrincessEnum.UNMET;
        var toReturn = `[p]
                            No!
                            You [b]aren't[/b] giving in to these darned [b]pests[/b]' venom.
                            While they're just simple insects doing whatever their instinct tells them to, you are [b]not[/b].
                            You may be at the bottom of the civilized world, but if there's anything you [i]are[/i] above, it is simple-minded creatures such as ants.
                        [/p]
                        [p]
                            This is a matter of principle.
                            You will [b]not[/b] be brought to your knees by a bunch of tiny six-legged freaks, 
                            no matter [b]how[/b] much your groin is [b]aching[/b] for attention.
                            You take a deep breath and steel your resolve.
                            ${male ? `With your member proudly protruding from your groin,` : `With your arousal beginning to seep down your inner thighs,`}
                            you begin to look for a new place to sleep.
                        [/p]
                        [p]
                            It isn't long before you come across a tiny blanket of moss, big enough for at least [i]some[/i] of your small frame to rest on.
                            Tiredness beginning to set in once more, you decide not to look any further.
                            You quickly check for anthills, and are glad to see that this time, there are none around.
                            You drop down to the ground, rest your head atop of the surprisingly soft moss, and within seconds manage to drift to sleep once more.
                        [/p]
                        [p]
                            Being as [i]excited[/i] as you are, your slumber is plagued by erotic dreams of various kinds.
                            One moment, you are tied up in a dungeon, getting abused by a sadistic, whip-armed fox.
                            The next, you find yourself getting caught by the soldiers that you robbed, 
                            a particularly buff looking wolf amongst them ramming his oversized knot inside of you.
                            ${sawDragoness ? `The blue-scaled dragoness also plays a role in your wet dreams. You envision yourself lapping at her folds while she rides your face, moaning in pleasure.` : ``}
                        [/p]
                        [p]
                            You slowly drift away from your pleasured dreams, waking up to find your hand having subconsciously drifted towards your groin.
                            During the night, you may have touched yourself a bit, but you proudly come to the conclusion that you [b]didn't[/b] masturbate.
                            You can practically [b]feel[/b] the ants' venom fading from your body, your arousal vanishing along with it.
                        [/p]
                        [p]
                            You let out a sigh of relief.
                            You've managed to retain your pride in the face of adversity, 
                            and you've won a figurative mental battle against a bunch of tiny, mindless bugs.
                            Regardless of the mediocrity of this achievement,
                            you feel content to know that you can remain in control of your body even when aroused.
                        [/p]
                        [p]
                            As the sun rises once again, so do you.
                            Getting up off of the ground, the coldness of the morning grips your body.
                            It washes away the heat of your arousal, like a dip in the river on a frigid winter night.
                            The last hint of your excitement vanishing, your mind turns to the future.
                        [/p]
                        [p]`;
        var gold = ctrl.gold();
        if (!gold) {
            toReturn += `   You are completely [b]broke[/b]. 
                            You have no money whatsoever to pay your overdue debts with.
                            Desperate times call for desperate measures.`;
        } else if (gold > 150) {
            toReturn += `   You have quite a bit of money, but sadly it's still not enough to pay your overdue debt.`;
        } else if (gold > 203) {
            toReturn += `   You have [b]a lot[/b] of money, more than you gained from just robbing the caravan, even.
                            You're [b]very[/b] close to being able to pay off your debt.
                            You just need a [i]teensy[/i] bit more.
                            But you aren't going to get it from these woods.`;
        }

        toReturn += `       You decide to head out, to seek your fortune in the great city of Varanar.
                            Maybe you'll stop at the small hamlet outside of the city walls along the way.
                            If anything, you hope you at least won't end up sleeping next to another anthill tonight.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.hasContinued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueHamletId}" ${disabled ? "disabled" : ""} style="margin: auto; float: left;">`;
        choice += `To the hamlet &gt;&gt`;
        choice += `</button>`;
        choice += `<button class="button bigbutton continuebutton" id="${continueVaranarId}" ${disabled ? "disabled" : ""} style="margin: auto; float: right;">`;
        choice += `To Varanar &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueHamletId), $("#" + continueVaranarId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next scene.
     * @param {string} sceneName Name of the scene to load.
     *  @param {string} folder Folder of the scene to load.
     */
    function loadNextPart(sceneName, folder) {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(sceneName, folder);
        });
    }

    /**
     * Adds a listener to the hamlet button.
     */
    function registerHamletListener() {
        $("#" + continueHamletId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.continue();
            loadNextPart(ctrl.hamletSceneName, ctrl.hamletFolder);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "homeWetDream";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.unsaved.shake.get() !== HomeShakeChoice.SLEEP) {
            return "";
        }
        global.ui.applyTheme("home_dawn");
        var change = ctrl.unsaved.wetChange();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += change;
        part += buildChoice();
        part += `<span class="todo">You can only go to the hamlet.</span>`;
        part += `</div>`;

        // BUILD CHILDREN HERE

        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.unsaved.shake.get() !== HomeShakeChoice.SLEEP) {
            return;
        }
        // REGISTER CHILDREN HERE

        if (ctrl.hasContinued()) {
            return;
        }

        registerHamletListener();
    };
}
