/**
 * Barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function BarnTable(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var injectId = "barnTableInjectButton";
    var unhingedId = "barnTableUnhingedButton";

    var toInject = new BarnInjection(ctrl);
    var toUnhinged = new BarnUnhinged(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var shirt = ctrl.misc.shirt();
        var bra = ctrl.misc.bra();
        var dick = ctrl.misc.dick();
        var cunt = ctrl.misc.cunt();
        var cuntVirgin = ctrl.misc.cuntVirgin();
        var gender = ctrl.misc.gender();
        var toReturn = `[p]
                            You try to come up with a suitable insult to hurl Cassidy's way,
                            yet your mind is far too busy trying to come up with a way to escape this darn table to think of anything.
                            All that escapes your lips is a deep, low, hate-filled growling.
                            She betrayed you.
                            She played you like a fool.
                            And now she's got you caught in her trap like a fly in a spider's web.
                        [/p]
                        [p]
                            "[color=orange]Now, now, my little [b]pet[/b].[/color]" the evil bitch says, noticing your furious glare.
                            While her voice seemed oh-so [b]alluring[/b] not a few minutes ago, at this very moment, you can't [b]stand[/b] her condescending tone.
                            Every word she says only fuels the raging fire that is your [b]hatred[/b] for the vixen.
                            "[color=orange]Settle down.[/color]" she resumes, the grin on her face turning souring into a scolding glance, annoyance audible in her voice.
                            "[color=orange]You wouldn't want me to revise my plans and send you to the [b]butcher[/b] instead of keeping you around as a breeder,
                            now would you?${dick ? " If anything, you should be grateful I'm willing to turn you into a girl just to keep you here." : ""}[/color]"
                        [/p]
                        [p]
                            T-the butcher?
                            Is that why she's breeding your kind?
                            To sell kobold offspring for their [b]meat[/b]?!
                            Mixed feelings of being sickened and terrified at the same time wash over you.
                            You feel an intense urge to [b]vomit[/b], yet your stomach's contents remain in place, which is probably for the best.
                        [/p]
                        [p]
                            As your glare fades to a pleading, scared, awestruck stare, a fresh smirk creeps onto Cassidy's face, as though she relishes in your fright.
                            "[color=orange]If you act like a good little slut, it'll be [b]your kids[/b] getting sent to the slaughterhouse instead of you.
                            And even then, not [b]all[/b] of them will end up on some nobleman's plate.
                            Some'll become slaves, others will get turned into expensive sex toys, and of course I'll keep a few for myself.[/color]"
                        [/p]
                        [p]
                            You are at a loss for words.
                            This bitch is [b]insane[/b].
                            Sure, your kind has no [i]official[/i] rights, but to be treated as a commodity, or worse, as cattle?!
                            To get [b]harvested[/b] for meat like scaly cows?!
                            Your mind can not comprehend how [b]anyone[/b] could treat a fellow sapient race like this.
                            Do kobolds -- and by extension: you -- matter [b]that[/b] little to the world?
                        [/p]
                        [p]
                            No.
                            This can't be happening.
                            It [b]has[/b] to be a bad dream.
                            You close your eyes and imagine you're still at home, resting in your bed, dreaming about some sadistic fox [b]whore[/b].
                            While the thought helps to calm you down a little, when you open your eyes,
                            you are sadly greeted with the sight of the barn and the vixen both.
                        [/p]
                        [p]
                            "[color=orange]Good. Now don't start growling again, or I'll have to gag you prematurely.[/color]"
                            Cassidy speaks, mistaking your slight calming for some form of acceptance.
                            Like you've already come to terms with what she plans on doing to you.
                            Like you'd [b]ever[/b] willingly agree to this [b]horrible[/b] life she has in store for you.
                            There's a million things you want to call her, yet you stay your tongue,
                            if just so you can [b]bite[/b] her later instead of getting your mouth plugged with whatever filthy rag she can produce.
                        [/p]
                        [p]
                            The canine turns around, facing away from you, her tail wagging excitedly,
                            her rear tauntingly swaying from side to side, as if to add insult to injury.
                            "[color=orange]Anyway, time for your first shot. I'll be [b]right[/b] back. Don't go anywhere![/color]"
                            She giggles at her own joke in a way that only a true [b]psychopath[/b] could,
                            as she begins to walk towards a nearby stash of what you can only presume to be Seki's
                            sold out ${global.kobold.inventory.createItemWithTooltip(new FemPlus())} supply.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildInjectChoice() {
        var disabled = ctrl.table.has() ? "disabled" : "";
        var isSelected = ctrl.table.get() === BarnTableChoice.INJECT;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${injectId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice button.
     */
    function buildUnhingedChoice() {
        var luck = ctrl.misc.luck();
        var luckyEnough = luck >= 6;
        var disabled = ctrl.table.has() || !luckyEnough ? "disabled" : "";
        var isSelected = ctrl.table.get() === BarnTableChoice.UNHINGED;
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${unhingedId}" ${disabled} style="width: 200px;">Unhinged cuff</button>`;

        var tooltip;
        if (luckyEnough) {
            tooltip = global.parser.parse(`One of the cuffs restraining your arms seems a bit loose. You might be able to pry it open.`);
        } else {
            tooltip = global.parser.parse(`Requires [b]6 luck[/b].`);
        }


        var popupContainer = global.ui.makeToolTip(button, tooltip, false, false, "width: 200px;");
        // Re-wrap with proper positioning.
        button = `<div class="inlinechoice">`;
        button += popupContainer;
        button += `</div>`;

        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildInjectChoice();
        choice += `<hr class="inlinechoiceseparator">`;
        choice += buildUnhingedChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + injectId), $("#" + unhingedId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + injectId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.table.set(BarnTableChoice.INJECT);
            loadNextPart(toInject);
        });
    }

    /**
     * Adds a listener to the button.
     */
    function registerUnhingedListener() {
        $("#" + unhingedId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.table.set(BarnTableChoice.UNHINGED);
            loadNextPart(toUnhinged);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "barnTable";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.eager.get() !== BarnEagerChoice.TABLE) {
            return "";
        }
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.table.change();
        part += buildChoice();
        part += toInject.build();
        part += toUnhinged.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.eager.get() !== BarnEagerChoice.TABLE) {
            return;
        }

        toInject.registerListeners();
        toUnhinged.registerListeners();

        if (ctrl.table.has()) {
            return;
        }

        registerContinueListener();
        registerUnhingedListener();
    };
}

var BarnTableChoice = {
    INJECT: 1,
    UNHINGED: 2
};
